org.apache.poi.ss.formula.eval

## Class TwoOperandNumericOperation

- java.lang.Object
- - org.apache.poi.ss.formula.functions.Fixed2ArgFunction
  - - org.apache.poi.ss.formula.eval.TwoOperandNumericOperation

- All Implemented Interfaces:
    ArrayFunction, Function, Function2Arg

      public abstract class TwoOperandNumericOperation
      extends Fixed2ArgFunction
      implements ArrayFunction

  Author:
    Josh Micich

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Function` | `AddEval`
    `static Function` | `DivideEval`
    `static Function` | `MultiplyEval`
    `static Function` | `PowerEval`
    `static Function` | `SubtractEval`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TwoOperandNumericOperation()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract double` | `evaluate(double d0, double d1)`
    `ValueEval` | `evaluate(int srcRowIndex, int srcColumnIndex, ValueEval arg0, ValueEval arg1)` see `Function.evaluate(ValueEval[], int, int)`
    `ValueEval` | `evaluateArray(ValueEval[] args, int srcRowIndex, int srcColumnIndex)`
    `protected double` | `singleOperandEvaluate(ValueEval arg, int srcCellRow, int srcCellCol)`

    - ### Methods inherited from class org.apache.poi.ss.formula.functions.Fixed2ArgFunction

      `evaluate`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.ss.formula.functions.ArrayFunction

      `evaluateOneArrayArg, evaluateTwoArrayArgs`

- - ### Field Detail

    - #### AddEval

          public static final Function AddEval

    - #### DivideEval

          public static final Function DivideEval

    - #### MultiplyEval

          public static final Function MultiplyEval

    - #### PowerEval

          public static final Function PowerEval

    - #### SubtractEval

          public static final Function SubtractEval

  - ### Constructor Detail

    - #### TwoOperandNumericOperation

          public TwoOperandNumericOperation()

  - ### Method Detail

    - #### singleOperandEvaluate

          protected final double singleOperandEvaluate(ValueEval arg,
                                                       int srcCellRow,
                                                       int srcCellCol)
                                                throws EvaluationException

      Throws:
        `EvaluationException`

    - #### evaluateArray

          public ValueEval evaluateArray(ValueEval[] args,
                                         int srcRowIndex,
                                         int srcColumnIndex)

      Specified by:
        `evaluateArray` in interface `ArrayFunction`
      Parameters:
        `args` - the evaluated function arguments. Empty values are represented with `BlankEval` or `MissingArgEval`, never `null`.
        `srcRowIndex` - row index of the cell containing the formula under evaluation
        `srcColumnIndex` - column index of the cell containing the formula under evaluation
      Returns:
        The evaluated result, possibly an `ErrorEval`, never `null`. Note - Excel uses the error code #NUM! instead of IEEE NaN, so when numeric functions evaluate to `Double.NaN` be sure to translate the result to `ErrorEval.NUM_ERROR`.

    - #### evaluate

          public ValueEval evaluate(int srcRowIndex,
                                    int srcColumnIndex,
                                    ValueEval arg0,
                                    ValueEval arg1)

      Description copied from interface: `Function2Arg`
      see `Function.evaluate(ValueEval[], int, int)`
      Specified by:
        `evaluate` in interface `Function2Arg`

    - #### evaluate

          protected abstract double evaluate(double d0,
                                             double d1)
                                      throws EvaluationException

      Throws:
        `EvaluationException`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.